library ieee;
use ieee.std_logic_1164.all;
 
entity test_debouncer is
end test_debouncer;
 
architecture behavior of test_debouncer is
    --Inputs
    signal clk      : std_logic := '0';
    signal reset    : std_logic := '0';
    signal btn_sw   : std_logic := '0';

    --Outputs
    signal db_tick  : std_logic;
    signal db_level : std_logic;

    -- Clock period definitions
    constant clk_period : time := 10 ns;
BEGIN
 
    -- Instantiate the Unit Under Test (UUT)
    uut: entity work.debounce(behavioral)
    generic map(N => 22)
    port map (
        clk         => clk,
        reset       => reset,
        btn_sw      => btn_sw,
        db_tick     => db_tick,
        db_level    => db_level
    );

    -- Clock process definitions
    clk_process :process
    begin
        clk <= '0';
        wait for clk_period/2;
        clk <= '1';
        wait for clk_period/2;
   end process;
 

    -- Stimulus process
    stim_proc: process
    begin        
        -- hold reset state for 100 ns.
        wait for 100 ns;  

        wait for clk_period*10;

        -- insert stimulus here
        btn_sw <= '1'; wait for 10ms;
        btn_sw <= '0'; wait for 10ms;
        btn_sw <= '1'; wait for 10ms;
        btn_sw <= '0'; wait for 10ms;
        btn_sw <= '1'; wait for 10ms;
        wait for 50ms;
        btn_sw <= '0'; wait for 10ms;
        btn_sw <= '1'; wait for 10ms;
        btn_sw <= '0'; wait for 10ms;
        btn_sw <= '1'; wait for 10ms;
        btn_sw <= '0'; wait for 10ms;
        wait for 50ms;

      wait;
   end process;

end;
