--------------------------------------------------------------------------------
-- Create Date:   10:21:18 10/08/2012
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
 
ENTITY test_peak_display IS
END test_peak_display;
 
ARCHITECTURE behavior OF test_peak_display IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT peak_display
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         mode : IN  std_logic;
         mean : IN  std_logic;
         init: IN  std_logic;
         peak_centroid : IN  std_logic_vector(11 downto 0);
         peak_moving : IN  std_logic_vector(11 downto 0);
         peak_output : OUT  std_logic_vector(11 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal mode : std_logic := '0';
   signal mean : std_logic := '0';
   signal init : std_logic := '0';
   signal peak_centroid : std_logic_vector(11 downto 0) := (others => '0');
   signal peak_moving : std_logic_vector(11 downto 0) := (others => '0');

 	--Outputs
   signal peak_output : std_logic_vector(11 downto 0);

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: peak_display PORT MAP (
          clk => clk,
          reset => reset,
          mode => mode,
          mean => mean,
          init => init,
          peak_centroid => peak_centroid,
          peak_moving => peak_moving,
          peak_output => peak_output
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
   
   -- Clock process definitions
   init_process :process
   begin
		init <= '0';
		wait for clk_period*10;
		init <= '1';
		wait for clk_period;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      reset <= '1';
      wait for 100 ns;
      reset <= '0';
      wait for clk_period*10;

      -- insert stimulus here
      mean <= '1';
      peak_centroid <= std_logic_vector( to_unsigned(2045,12) );
      peak_moving   <= std_logic_vector( to_unsigned(1145,12) );
      wait;
   end process;

END;
